'Projekt-Einstellungen:
'Option Strict On
'Option Explicit On
'Imports System.Windows.Forms
'Imports System.Drawing
'Imports Microsoft.VisualBasic.ControlChars

Imports System.Drawing.Imaging
Imports System.IO

Public Class frmColorMatrix

    Private _GDest As Graphics 'Graphics des zu aktualisierenden Images
    Private _DrawAttr As New Imaging.ImageAttributes()

    Private Sub frmColorMatrix_Load( _
            ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        Using Bmp As New Bitmap("Colors.jpg")
            Me.picSrc.BackgroundImage = CreateArgbCopy(Bmp)
        End Using
        'Eine berlagerung zweier Bilder wird implementiert, indem der Ziel-Picturebox sowohl ein BackgroundImage als auch ein Image zugewiesen wird
        Me.picDest.BackgroundImage = New Bitmap("Colgate-Pig.jpeg")
        Me.picDest.Image = New Bitmap( _
            picDest.Width - 50, _
            picDest.Height - 30, _
            PixelFormat.Format32bppArgb)
        _GDest = Graphics.FromImage(Me.picDest.Image)
        ApplyColormatrix()
    End Sub

    ''' <summary>
    ''' konvertiert eine RGB-Bitmap ins ARGB-Format (Alpha-Komponente:
    ''' Farbsttigung)
    ''' </summary>
    Private Function CreateArgbCopy(ByVal Img As Image) As Bitmap
        CreateArgbCopy = New Bitmap( _
            Img.Width, Img.Height, PixelFormat.Format32bppArgb)
        Using G As Graphics = Graphics.FromImage(CreateArgbCopy)
            Dim Rct As New Rectangle(Point.Empty, Img.Size)
            G.DrawImage(Img, Rct, Rct, GraphicsUnit.Pixel)
        End Using
    End Function

    Private Sub UclColormatrix1_ColorMatrixChanged( _
            ByVal sender As Object, ByVal e As EventArgs) _
            Handles UclColormatrix1.ColorMatrixChanged
        ApplyColormatrix()
    End Sub

    Private Sub ApplyColormatrix()
        _GDest.Clear(Color.Transparent)
        _DrawAttr.SetColorMatrix(UclColormatrix1.ColorMatrix)
        Dim Src As Image = Me.picSrc.BackgroundImage
        _GDest.DrawImage( _
            Src, _
            Rectangle.Round(_GDest.VisibleClipBounds), _
            0, 0, Src.Width, Src.Height, _
            GraphicsUnit.Pixel, _
            _DrawAttr)
        picDest.Invalidate()
    End Sub

    Private Sub frmColorMatrix_Disposed( _
            ByVal sender As Object, ByVal e As EventArgs) Handles Me.Disposed
        For Each D As IDisposable In New IDisposable() { _
                _GDest, _
                _DrawAttr, _
                picSrc.BackgroundImage, _
                picDest.BackgroundImage, _
                picDest.Image}
            D.Dispose()
        Next
    End Sub

End Class
