Imports System
Imports System.Diagnostics

Public Module modHelpers

   ''' <summary>
   ''' Normiert ScrollBar.Value auf einen Wert zw. 0 und 1
   ''' </summary>
   Public Property NormedScrollValue(ByVal Scrollbar As ScrollBar) As Double
      Get
         With Scrollbar
            Return .Value / (.Maximum - (.LargeChange - 1))
         End With
      End Get
      Set(ByVal value As Double)
         If Not IsBetween(0.0, value, 1.0) Then Throw New Exception( _
             String.Concat( _
                 "Value '", value, "' liegt nicht zwischen 0 und 1."))
         With Scrollbar
            Dim Val As Integer = _
                CInt(value * (.Maximum - (.LargeChange - 1)))
            If Val = .Value Then Return
            .Value = Val
         End With
      End Set
   End Property

   ''' <summary>
   ''' Normiert ScrollBar.Value auf einen Wert zw. ScaleMin und ScaleMax 
   ''' </summary>
   Public Property NormedScrollValue( _
           ByVal ScrollBar As ScrollBar, _
           ByVal ScaleMin As Double, _
           ByVal ScaleMax As Double) As Double
      Get
         Return NormedScrollValue(ScrollBar) * (ScaleMax - ScaleMin) + ScaleMin
      End Get
      Set(ByVal value As Double)
         NormedScrollValue(ScrollBar) = (value - ScaleMin) / (ScaleMax - ScaleMin)
      End Set
   End Property


   Public Function IsBetween(Of T As IComparable)( _
         ByVal Bord0 As T, _
         ByVal ToTest As T, _
         ByVal Bord1 As T, _
         Optional ByVal AutoSort As Boolean = False) As Boolean
      If AutoSort Then
         Dim C0 As Integer = Bord0.CompareTo(ToTest)
         Dim C1 As Integer = ToTest.CompareTo(Bord1)
         Return C0 = 0 OrElse C1 = 0 OrElse (C0 < 0) = (C1 < 0)
      Else
         Return Bord0.CompareTo(ToTest) <= 0 AndAlso ToTest.CompareTo(Bord1) <= 0
      End If
   End Function

End Module
