Imports System.Drawing.Imaging

'''<summary>
''' UserControl, kombiniert eine Scrollbar mit einem Grid, welches die 
''' 5*5 Elemente einer ColorMatrix anzeigt: Das Grid whlt das gewnschte 
''' Matrix-Element an,die Scrollbar stellt den Wert ein
''' </summary>
Public Class uclColormatrix

    Public ReadOnly ColorMatrix As New ColorMatrix

    Public Event ColorMatrixChanged As EventHandler

    Private Sub uclColormatrix_Load( _
            ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        Me.MatrixGrid.RowCount = 5
        For Y As Integer = 0 To 4
            For X As Integer = 0 To 4
                Me.MatrixGrid(X, Y).Value = ColorMatrix(Y, X)
            Next
        Next
        UpdateScroll()
    End Sub

    Private Sub UpdateScroll()
        NormedScrollValue(HScrollBar1) = CSng(MatrixGrid.CurrentCell.Value)
    End Sub

    Private Sub MatrixGrid_CurrentCellChanged( _
            ByVal sender As Object, ByVal e As EventArgs) _
            Handles MatrixGrid.CurrentCellChanged
        UpdateScroll()
   End Sub

   'Zeilenbeschriftung anbringen - entsprechend den ColumnHeaderTexten
   Private Sub MatrixGrid_CellPainting( _
           ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs) _
           Handles MatrixGrid.CellPainting
      'Die Zeilenkpfe werden mit ColumnIndex=-1 angesprochen 
      If e.ColumnIndex < 0 AndAlso e.RowIndex >= 0 Then
         e.PaintBackground(e.CellBounds, False)
         With MatrixGrid
            TextRenderer.DrawText( _
                e.Graphics, _
                .Columns(e.RowIndex).HeaderText, _
                .Font, _
                e.CellBounds, _
                .ForeColor)
         End With
         e.Handled = True
      End If
   End Sub

   'Scroll-Wert in Grid und Colormatrix eintragen, dann Event raisen
   Private Sub HScrollBar1_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) _
         Handles HScrollBar1.ValueChanged
      Dim ScrollVal As Single = CSng(NormedScrollValue(HScrollBar1))
      With MatrixGrid.CurrentCell
         If ScrollVal.Equals(.Value) Then Return
         .Value = ScrollVal
         ColorMatrix(.RowIndex, .ColumnIndex) = ScrollVal
      End With
      RaiseEvent ColorMatrixChanged(Me, EventArgs.Empty)
   End Sub

End Class
